/******************************************************************************
*
*                        Microchip File I/O Library
*
******************************************************************************
* FileName:           sd_spi_config.h
* Processor:          PIC18/PIC24/dsPIC30/dsPIC33
* Compiler:           XC8/XC16
* Company:            Microchip Technology, Inc.
*
* Software License Agreement
*
* The software supplied herewith by Microchip Technology Incorporated
* (the "Company") for its PICmicro(R) Microcontroller is intended and
* supplied to you, the Company's customer, for use solely and
* exclusively on Microchip PICmicro Microcontroller products. The
* software is owned by the Company and/or its supplier, and is
* protected under applicable copyright laws. All rights are reserved.
* Any use in violation of the foregoing restrictions may subject the
* user to criminal sanctions under applicable laws, as well as to
* civil liability for the breach of the terms and conditions of this
* license.
*
* THIS SOFTWARE IS PROVIDED IN AN "AS IS" CONDITION. NO WARRANTIES,
* WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING, BUT NOT LIMITED
* TO, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
* PARTICULAR PURPOSE APPLY TO THIS SOFTWARE. THE COMPANY SHALL NOT,
* IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL OR
* CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.
*
* ============================================================================ *
*   VERSION DATE       BY                   CHANGE/COMMENT                     *
* ---------------------------------------------------------------------------- *
*   1.00    2017-02-11 ޒH[(ނ) {Rgǉ                 *
*
********************************************************************/

//-------------Function name redirects------------------------------------------
// During the media initialization sequence for SD cards, it is
// necessary to clock the media at a frequency between 100 kHz and 400 kHz,
// since some media types power up in open drain output mode and cannot run
// fast initially.
// SDJ[h̃fBAV[PXł́A
// ꕔ̃fBA^CvI[vhCo̓[hŋNAŏ͍œ삷鎖oȂׁA
// 100kHz`400kHz̎gŃfBANbN삷KvL܂B

// On PIC18 devices, when the CPU is running at full frequency, the standard SPI
// prescalars cannot reach a low enough SPI frequency.  Therefore, we provide these
// configuration options to allow the user to remap the SPI functions called during
// the "slow" part of the initialization to user-implemented functions that can
// provide the correct functionality.  For example, a bit-banged SPI module could
// be implemented to provide a clock between 100 and 400 kHz.
// PIC18foCXł́ACPUtgœ삵ĂꍇAWSPIvXP[
// \ɒႢSPIgɐݒo܂B
// āA̐ݒIvVgpāA[Uݒ́uxv
// ĂяoꂽSPI֐A@\񋟏o郆[U֐ɍă}bvolɂ܂B
// Ⴆ΁ArbgofBOꂽSPIW[100`400kHz̃NbN񋟂鎖oB

// For PIC18 versions of this demo, the slow functions are mapped to the fast SPI driver functions.
// The slower clock frequency will be achieved by disabling the PLL during the
// SD Card initialization.  Note that the SYS_CLK_FrequencySystemGet function 
// was implemented to return the correct clock frequency when using both a PLL-enabled 
// or PLL-disabled clock.
// ̃fPIC18o[Wł́Aᑬ@\SPIhCo@\Ƀ}bsOĂ܂B
// xNbNǵASDJ[h̏PLL"֎~"鎖ɂĎ܂B
// SYS_CLK_FrequencySystemGet֐("system.h")́APLL""ꂽNbN܂́A
// PLL"֎~"ꂽNbN̗gp鎞ɐNbNgԂlɎĂ܂B

#if defined (__XC8)
    // Define the function to initialize the SPI module for operation at a slow clock rate
    #define FILEIO_SD_SPIInitialize_Slow    FILEIO_SD_SPISlowInitialize
    // Define the function to send a media command at a slow clock rate
    #define FILEIO_SD_SendMediaCmd_Slow     FILEIO_SD_SendCmdSlow
    // Define the function to write an SPI byte at a slow clock rate
    #define FILEIO_SD_SPI_Put_Slow          DRV_SPI_Put
    // Define the function to read an SPI byte at a slow clock rate
    #define FILEIO_SD_SPI_Get_Slow          DRV_SPI_Get
#else
    // xNbN[gœ삷lSPIW[֐`
    #define FILEIO_SD_SPIInitialize_Slow    FILEIO_SD_SPISlowInitialize
    // ᑬNbN[gŃfBAR}h𑗐M֐`
    #define FILEIO_SD_SendMediaCmd_Slow     FILEIO_SD_SendCmd
    // ᑬNbN[gSPIoCgފ֐`
    #define FILEIO_SD_SPI_Put_Slow          DRV_SPI_Put
    // xNbN[gSPIoCgǂݎ֐`
    #define FILEIO_SD_SPI_Get_Slow          DRV_SPI_Get
#endif

// RgƁASDJ[h̃\tgoLɂȂ܂B
// J[hosȂA\tgEFAgpăJ[h݂̑oKvL܂B
// J[ho(CD)szꍇ́ARg{܂B
// A"system.c""SDSPI_CD_PIN"ŐڑJ[ho(CD)s̎ws܂B
#define FILEIO_SD_CONFIG_MEDIA_SOFT_DETECT


